<?php

$lineBr = "\n";
$outputLogs = "/boot/TheCross/TT_OutputLogs/";
$todaysLog = $outputLogs."Output_".date("mdy");

$restart_necessary = false;

//search output log
$logFileHandle = fopen($todaysLog, "r") or exit("Unable to open log file!");
$logFileContent = fread($logFileHandle, filesize($todaysLog));
fclose($logFileHandle);

//trim content
$logFileContent = trim($logFileContent);

//find last logged line
$lastLogLine = substr($logFileContent, strrpos($logFileContent, "\n"));
$lastLogLine = trim($lastLogLine);

//examine last line in the output log
if(strpos($lastLogLine, "silence-sense")) {
  $restart_necessary = true; //restart system
}

//write action to log file
if($restart_necessary) {
  adminLog(date("Y-m-d G:i:s").": ACTION: RESTART (Last Log Line: ".$lastLogLine.")");
}
else {
  adminLog(date("Y-m-d G:i:s").": ACTION: - - - - (Last Log Line: ".$lastLogLine.")");
}

//perform action
$myActionFile = "/boot/TheCross/Silence_Checker/Run_Action";
$myActionFileHandle = fopen($myActionFile, 'a') or die("can't open action file to append");
$line = "";
if($restart_necessary) {
  $line .= "shutdown -r".$lineBr.$lineBr;
  restartLog(date("Y-m-d G:i:s").": ACTION: RESTART (Last Log Line: ".$lastLogLine.")");
}
$line .= "exit";
fwrite($myActionFileHandle, $line);
fclose($myActionFileHandle);


//logs to a daily log, reports the last log line of each test
function adminLog($text) {
  global $lineBr;
  $text = $text.$lineBr;
  $myFile = "silence_checker_log_".date("Y-m-d").".txt";
  $myFileHandle = fopen($myFile, "a") or die("can't open log file to append");
  fwrite($myFileHandle, $text);
  fclose($myFileHandle);
}

//logs only restarts to a restart log (one file)
function restartLog($text) {
  global $lineBr;
  $text = $text.$lineBr;
  $myFile = "restart_log.txt";
  $myFileHandle = fopen($myFile, "a") or die("can't open log file to append");
  fwrite($myFileHandle, $text);
  fclose($myFileHandle);
}

?>